'''
Created on 13/11/2009

@author: George
'''
import wx

from edu.ufrpe.controlePessoas.entidades import Pessoa

class RepositorioPessoa:
    
    def __init__(self, enderecoArquivo, pai):
        self.parent = pai
        self.enderecoArquivo = enderecoArquivo
        self.arquivo = None
        
    def __abreArquivo(self, opcao):
        if(self.arquivo == None):
            self.arquivo = open(self.enderecoArquivo,opcao)
    
    def __fechaArquivo(self):
        if(self.arquivo != None):
            self.arquivo.close()
            self.arquivo = None
    
    def inserirPessoa(self, pessoa):
        self.__abreArquivo("a")
        strInsercao = str(pessoa.getCpf())+"#"+str(pessoa.getNome())+"#"+str(pessoa.getIdade())+"#"+str(pessoa.getGenero())+"#\n"
        self.arquivo.write(strInsercao)
        self.__fechaArquivo()
        dial = wx.MessageDialog(None, 'Cadastro Realizado com Sucesso !!!', ':: Cadastro Realizado com Sucesso ::',style = wx.OK)
        ret = dial.ShowModal()
    
    def alterarPessoa(self, pessoa):
        self.__abreArquivo("r")
        listaPessoas = self.getListaPessoas()
        indice = 0
        
        for i in listaPessoas:
            if i.getCpf() == pessoa.getCpf:
                indice = listaPessoas.index(i)
        
        listaPessoas[indice] = pessoa
        self.__fechaArquivo()
        self.__gravarPessoas(listaPessoas)
        dial = wx.MessageDialog(None, 'Alteracao Realizada com Sucesso !!!', ':: Alteracao Realizada com Sucesso  ::',style = wx.OK)
        ret = dial.ShowModal()

        
    def __gravarPessoas(self, listaPessoas):
        self.__abreArquivo("w")
        listaInsercao = []
        for pessoa in listaPessoas:
            strInsercao = str(pessoa.getCpf())+"#"+str(pessoa.getNome())+"#"+str(pessoa.getIdade())+"#"+str(pessoa.getGenero())+"#\n"
            listaInsercao.append(strInsercao)

        self.arquivo.writelines(listaInsercao)
        self.__fechaArquivo()
        
    def getListaPessoas(self):
        self.__abreArquivo("r")
        lista = self.arquivo.readlines()
        
        listaPessoas = []
        
        for i in lista:
            listaDados = i.rsplit("#")
            cpf = listaDados[0]
            nome = listaDados[1]
            idade = listaDados[2]
            genero = listaDados[3]
            p = Pessoa.Pessoa(cpf, nome, idade, genero)
            listaPessoas.append(p)
        
        self.__fechaArquivo()
        return listaPessoas
        
        
    def removerPessoa(self, pessoa):
        self.__abreArquivo("r")
        listaPessoas = self.getListaPessoas()
        novaLista = []
        for i in listaPessoas:
            if i.getCpf() != pessoa.getCpf():
                novaLista.append(i)
        
        self.__fechaArquivo()
        self.__gravarPessoas(novaLista)
        
        dial = wx.MessageDialog(None, 'CPF '+pessoa.getCpf()+' Removido com Sucesso !!!', ':: Remocao Realizada com Sucesso  ::',style = wx.OK)
        ret = dial.ShowModal()
    